var xmlHTTP;

var theForm;
var btnSubmit;
var txtEmail;

var verify;
var verifyMsg;
var txtVerify;
var btnVerify;

var emailMsg;

var emailValidate = 'email_validate.php?action=';

function startupState()
{
	verify.style.display = 'none';
	verifyMsg.innerHTML = '';

	txtVerify.removeAttribute('disabled');

	btnVerify.removeAttribute('disabled');
	btnVerify.innerHTML = 'Verify';

	btnSubmit.setAttribute('disabled', 'disabled');

	emailMsg.innerHTML = '';
	theForm.email_id.value = '';
	theForm.v_code.value = '';
}

function validateAddress()
{
	var email = theForm.email.value;
	var id = parseInt(theForm.email_id.value);

	startupState();

	if (email != '') {
		var dataString = 'email=' + encodeURIComponent(email);
		
		if (id > 0) {
			dataString += '&id=' + id;
		} 


	} else {
		return;
	}

	xmlHTTP.open('get', emailValidate + 'validate&' + dataString, true);
	xmlHTTP.onreadystatechange = parseResponse;
	xmlHTTP.send(null);


}

function validateCallback(response)
{

	if (response['status']) {
		emailMsg.style.display = 'none';
		
		verify.style.display = 'inline';
		verifyMsg.innerHTML = '<b>An Email containing your verification code has been sent to this address. Please Enter it before continuing.</b>';
		theForm.email_id.value = response['data'];
	} else {
		verify.style.display = 'none';
		emailMsg.innerHTML = '<b>You have entered an invalid email address. Please correct it before continuing.</b>';
		emailMsg.style.display = 'block';
	}
}

function verifyAddress()
{
	var v_code = theForm.v_code.value;
	var id = theForm.email_id.value;

	if (v_code == '') {
		alert('No Verification Code Entered');
		theForm.v_code.focus();
		return;
	}

	var dataString = 'id=' + encodeURIComponent(id) + '&v_code=' + encodeURIComponent(v_code); 

	xmlHTTP.open('get', emailValidate + 'verify&' + dataString, true);
	xmlHTTP.onreadystatechange = parseResponse;
	xmlHTTP.send(null);
}

function verifyCallback(response)
{
	var v_code = theForm.v_code.value;
	
	theForm.email_id.value = response['data'];

	if(response['status']) { // successfull verification
		btnVerify.setAttribute('disabled', 'disabled');
		txtVerify.setAttribute('disabled', 'disabled');

		btnVerify.innerHTML = '<i>Verified</i>';
		verifyMsg.innerHTML = '';
		
		btnSubmit.removeAttribute('disabled');
		
		verifyMsg.innerHTML = '<b><i>' + theForm.email.value + '</i></b>';
		theForm.email.value = '';
	} else {
		verifyMsg.innerHTML = '<b>Verification Failed</b>';
	}


}



function parseResponse()
{
	if (xmlHTTP.readyState != 4) {
		/* the request is not complete */
		return;
	}

	var responseArray = xmlHTTP.responseText.split(';');
	var response = Array();

	if (responseArray.length != 3) {
		/* response is invalid */
		return;
	}
	
	/* load the response into a logical associative array */
	response['status'] = parseInt(responseArray[0]);
	response['data'] = responseArray[1];
	response['context'] = responseArray[2];

	/* decide what to do based onthe reponse context */
	switch(response['context']) {
		case 'validate':
			validateCallback(response);
			break;
		case 'verify':
			verifyCallback(response);
			break;
		case 'invalid':
			// return everything to its original state and start over
			startupState();
			validateAddress();
			break;
		case 'unknownerror':
			// something is wrong - so we are going to fall back
			btnSubmit.removeAttribute('disabled');
			txtEmail.onchange = null;
			verify.style.display = 'none';
			break;
	}
}

/* initializes the environment and sets up all variables - called on the onload event of the document body */
function init()
{
	/* close the document output*/
	document.close();

	xmlHTTP = getXMLHTTP();


	if (! xmlHTTP) {
		/* do not continue if XML HTTP is not available */
		return;
	}

	/* initialize global variables */
	theForm = document.getElementById('formEmail');
	btnSubmit = document.getElementById('btnSubmit');
	txtEmail =  document.getElementById('txtEmail')
	verify =  document.getElementById('verify')
	verifyMsg =  document.getElementById('verifyMsg');
	txtVerify =  document.getElementById('txtVerify');
	btnVerify = document.getElementById('btnVerify');
	emailMsg =  document.getElementById('emailMsg');
	
	/* disable the submit button */
	btnSubmit.setAttribute('disabled', 'disabled');
	
	txtEmail = document.getElementById('txtEmail');

	/* set the onchange event of the email input box to the validateAddress() function */
	txtEmail.onchange = validateAddress;
}


function getXMLHTTP()
{
	if ((typeof XMLHttpRequest) != "undefined") {
		/* XMLHTTPRequest present, use that */
		return new XMLHttpRequest();
	} else if (window.ActiveXObject) {
		/*  there are several versions of IE's Active X control, use the most recent one available */
		var xmlVersions = ["MSXML2.XMLHttp.5.0",
				   "MSXML2.XMLHttp.4.0",
				   "MSXML2.XMLHttp.3.0",
				   "MSXML2.XMLHttp",
				   "Microsoft.XMLHTTP"];

		for (var x =0; x < xmlVersions.length; x++) {
			try {
				var xmlHTTP = new ActiveXObject(xmlVersions[x]);
				return xmlHTTP;
			} catch (e) {
				//continue looping
			}
		}
	}

	/* if none of that worked, return false, to indicate failure */
	return false;
}
