<?php
if(isset($_GET['viewsource'])) {
	highlight_file(__FILE__);
	exit;
}

	require_once 'email_validator.php';

	/* AJAX sender will have data sent to client in format:
		status;data;context

		status = was the request successfull - 1 | 0
		data = return data
		context = context of original request
	*/
	
	/* get the action */
	$action = @$_GET['action'];
			

	if (isset($_GET['id'])) {
		/* the user has already made a request and been given an email ID */
		try {
			$email = new EmailValidator((int)$_GET['id']);
		
			if (isset($_GET['email'])) {
				/* a new email has been sent, so we must re-validate */
				$email->setEmail($_GET['email']);
				$action = 'validate';
			}
		} catch (EmailValidatorException $e) {
			if (isset($_GET['email'])) {
				/* the ID was invalid, but we have been sent an email address */
				$email = new EmailValidator($_GET['email']);
				$action = 'validate';
			} else {
				/* an invalid ID was specified and no email address was given - we cannot do much */
				$action = 'invalid';
			}
		} catch (Exception $e) {
			$action = 'unknownerror';
		}
	} else if (isset($_GET['email'])) {
		try {
			/* load the new email into the validator */
			$email = new EmailValidator($_GET['email']);
		} catch (Exception $e) {
			$action = 'unknownerror';
		}
	} else {
		/* no action sent  we cannot do much */
		$action = 'invalid';
	}

	
	$data = '';
	switch ($action) {
		case 'validate':	
			$ret = validate_email($email);
			$data = (string) $email->getId();
			break;
		case 'verify':
			try {
				$ret = $email->verify(@$_GET['v_code']);
			} catch (EmailValidatorException $e) {
				/* the email has not been validated - validate it now */
				$action = 'validate';
				$ret = validate_email($email);
			}
			
			$data = (string) $email->getId();
			break;
		case 'unknownerror':
			$ret = 0;
			break;
		default:
			//fail
			$action = 'invalid';
			$ret = 0;
	}
	
	/* send the response as plain text */
	header('Content-Type: text/plain');
	echo((int) $ret . ';' . $data . ';' . $action);

	function validate_email(EmailValidator $email)
	{
		/* validate the email */
		if(! $email->validate()) {
			return false;
		}
		
		$email->save(); // save it to the database
		$email->sendVerificationEmail(); // send the verification email

		return true;
	}
?>
